#######################################################

#Copyright (C) IBM Corp. 2005-2016, All rights reserved.

#Author:

#Notes: 1. Use elements from MSCluster_ClusterSharedVolume class
#ClusWMI MOF file

#Revision History:

#######################################################

#Get-Module -list
#Import the FailoverClusters module into a Windows PowerShell session 

$ErrorActionPreference = "Stop"

Import-Module FailoverClusters

$objs = @()

$csvs = Get-ClusterSharedVolume

Echo ""
Echo ""
Echo "Start List Of All Volumes"  
Echo ===============================================  

foreach ( $csv in $csvs )
{
   $csvinfos = $csv | select -Property Name -ExpandProperty SharedVolumeInfo
   foreach ( $csvinfo in $csvinfos )
   {
      
	$Signature = ( $csv | Get-ClusterParameter DiskSignature ).Value.substring(2) 

	$obj = New-Object PSObject -Property @{
         Name        = $csv.Name
         CSVPath        = $csvinfo.FriendlyVolumeName
         Size        = $csvinfo.Partition.Size
         FreeSpace   = $csvinfo.Partition.FreeSpace
         UsedSpace   = $csvinfo.Partition.UsedSpace
         PercentFree = $csvinfo.Partition.PercentFree
	 PhysicalDisk  = ( Get-WmiObject Win32_DiskDrive | Where { "{0:x}" -f $_.Signature -eq $Signature } ).DeviceID.substring(4)
	 DiskNumber = ( Get-WmiObject Win32_DiskDrive | Where { "{0:x}" -f $_.Signature -eq $Signature } ).DeviceID.substring(4)
	 #SerialNumber = $csvinfo.Partition.SerialNumber
	 
	
      }
	                
        ($obj).DiskNumber = $obj.DiskNumber -replace '\D+(\d+)','$1'

	($obj).PhysicalDisk = ($obj).PhysicalDisk -Replace "PHYSICALDRIVE", "Disk " 


      $objs += $obj
   }
}

	 $app = 'C:\Program Files\IBM\SDDDSM\datapath.exe'
	 $arg1 = 'query'
	 $arg2 = 'device'
	 #$arg3 = ($obj).DiskNumber-1
	 
	 & $app $arg1 $arg2 

	 Echo ""
	 Echo ""
     Echo "End List Of All Volumes"  
     Echo =============================================== 
	 
Echo ""
Echo ""
Echo "Start List Of Cluster Shared Volumes"  
Echo ===============================================  

$objs | ft -auto Name,DiskNumber,CSVPath,PhysicalDisk, @{ Label = "Size(GB)" ; 
Expression = { "{0:N2}" -f ($_.Size/1024/1024/1024) } },@{ Label = "FreeSpace(GB)" ; 
Expression = { "{0:N2}" -f ($_.FreeSpace/1024/1024/1024) } },@{ Label = "UsedSpace(GB)" ; 
Expression = { "{0:N2}" -f ($_.UsedSpace/1024/1024/1024) } },@{ Label = "PercentFree" ; 
Expression = { "{0:N2}" -f ($_.PercentFree) } }


Echo ""
Echo ""
Echo "End List Of Cluster Shared Volumes"  
Echo ===============================================  